diff --git a/build.gradle.kts b/build.gradle.kts
index 9b1ff4992..561df0df9 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -1,5 +1,6 @@
 import com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar
 import com.github.jengelman.gradle.plugins.shadow.transformers.Log4j2PluginsCacheFileTransformer
+import org.gradle.internal.os.OperatingSystem
 import java.text.SimpleDateFormat
 import java.util.*
 
@@ -88,15 +89,58 @@ repositories {
         }
         metadataSources { artifact() }
     }
+    jcenter()
 }
 
+val lwjglVersion = "3.3.4"
+
+val lwjglNatives = Pair(
+    System.getProperty("os.name")!!,
+    System.getProperty("os.arch")!!
+).let { (name, arch) ->
+    when {
+        arrayOf("Linux", "SunOS", "Unit").any { name.startsWith(it) } ->
+            if (arrayOf("arm", "aarch64").any { arch.startsWith(it) })
+                "natives-linux${if (arch.contains("64") || arch.startsWith("armv8")) "-arm64" else "-arm32"}"
+            else if (arch.startsWith("ppc"))
+                "natives-linux-ppc64le"
+            else if (arch.startsWith("riscv"))
+                "natives-linux-riscv64"
+            else
+                "natives-linux"
+        arrayOf("Mac OS X", "Darwin").any { name.startsWith(it) }     ->
+            "natives-macos${if (arch.startsWith("aarch64")) "-arm64" else ""}"
+        arrayOf("Windows").any { name.startsWith(it) }                ->
+            if (arch.contains("64"))
+                "natives-windows${if (arch.startsWith("aarch64")) "-arm64" else ""}"
+            else
+                "natives-windows-x86"
+        else                                                                            ->
+            throw Error("Unrecognized or unsupported platform. Please set \"lwjglNatives\" manually")
+    }
+}
 dependencies {
     implementation("org.jetbrains:annotations:24.0.0")?.let { clientInclude(it); serverInclude(it) }
-    val lwjglVersion = "2.9.3"
-    implementation("org.lwjgl.lwjgl:lwjgl_util:${lwjglVersion}")
-    implementation("org.lwjgl.lwjgl:lwjgl:${lwjglVersion}")
-    runtimeOnly("org.lwjgl.lwjgl:lwjgl-platform:${lwjglVersion}")
-
+    implementation("com.github.Zarzelcow:legacy-lwjgl3:78643b2a96") {
+        exclude(group = "net.fabricmc")
+        exclude(group = "org.lwjgl")
+        exclude(group = "org.jetbrains.kotlin")
+        exclude(group = "org.javassist")
+    }.let { clientInclude(it) }
+    implementation(platform("org.lwjgl:lwjgl-bom:$lwjglVersion"))
+
+    implementation("org.lwjgl", "lwjgl")
+    implementation("org.lwjgl", "lwjgl-assimp")
+    implementation("org.lwjgl", "lwjgl-glfw")
+    implementation("org.lwjgl", "lwjgl-openal")
+    implementation("org.lwjgl", "lwjgl-opengl")
+    implementation("org.lwjgl", "lwjgl-stb")
+    runtimeOnly("org.lwjgl", "lwjgl", classifier = lwjglNatives)
+    runtimeOnly("org.lwjgl", "lwjgl-assimp", classifier = lwjglNatives)
+    runtimeOnly("org.lwjgl", "lwjgl-glfw", classifier = lwjglNatives)
+    runtimeOnly("org.lwjgl", "lwjgl-openal", classifier = lwjglNatives)
+    runtimeOnly("org.lwjgl", "lwjgl-opengl", classifier = lwjglNatives)
+    runtimeOnly("org.lwjgl", "lwjgl-stb", classifier = lwjglNatives)
     implementation("com.google.code.gson:gson:2.10.1")?.let { clientInclude(it); serverInclude(it) }
 
     implementation("com.github.JnCrMx:discord-game-sdk4j:v0.5.5")?.let { clientInclude(it) }
diff --git a/src/common/resources/lang/en_US/gui.lang b/src/common/resources/lang/en_US/gui.lang
index 786e3e45b..a04074ff7 100644
--- a/src/common/resources/lang/en_US/gui.lang
+++ b/src/common/resources/lang/en_US/gui.lang
@@ -7,6 +7,14 @@ gui.achievements.button.done=Done
 gui.achievements.label.title=Achievements
 gui.achievements.label.taken=Taken!
 gui.achievements.label.requires=Requires '%1$s'
+gui.achievements.label.completion=%1$s Complete!
+
+gui.achievements.page.vanilla.name=Vanilla
+gui.achievements.page.vanilla.desc=Achievements from Better than Adventure!
+gui.achievements.page.overworld.name=Overworld
+gui.achievements.page.overworld.desc=Achievements of the starting dimension!
+gui.achievements.page.nether.name=Nether
+gui.achievements.page.nether.desc=Achievements from Hell!
 
 gui.add_server.label.title=Add server
 gui.add_server.button.save=Save
@@ -55,8 +63,6 @@ gui.connecting.label.connecting=Connecting to the server...
 gui.connecting.label.logging_in=Logging in...
 
 gui.controller_setup.button.back=Back
-gui.controller_setup.label.help.1=If no controllers are detected, make sure to
-gui.controller_setup.label.help.2=launch the game with the controller plugged in.
 gui.controller_setup.label.no_controller_selected=No controller selected!
 
 gui.crafting.label.crafting=Crafting
@@ -157,6 +163,7 @@ gui.main_menu.button.quit_game=Quit Game
 gui.main_menu.button.discord=Discord
 gui.main_menu.button.youtube=YouTube
 gui.main_menu.button.website=Website
+gui.main_menu.button.credits=Credits
 
 gui.out_of_memory.label.title=Out of memory!
 gui.out_of_memory.label.body.1=Minecraft has run out of memory.
@@ -224,11 +231,33 @@ gui.options.page.debug.category.test=Tests
 gui.options.page.debug.button.open.model_viewer=Open Model Viewer
 gui.options.page.debug.button.open.biome_finder=Open Biome Finder
 gui.options.page.debug.button.open.datadumper=Run Data Dumper
+gui.options.page.debug.button.open.sound_test=Open Sound Test
+gui.options.page.debug.button.open.texture_viewer=Open Texture Viewer
+gui.options.page.debug.button.open.achievements=Open Achievements
+gui.options.page.debug.button.wipestats=Delete Stats
+gui.options.page.debug.button.unlockedall=Unlock all stats
+gui.options.page.debug.button.cheat=Enable Cheats
 gui.options.page.debug.button.crash.soft=Crash Soft
 gui.options.page.debug.button.crash.hard=Crash Hard
+gui.options.page.debug.button.music.skip=Force Ambient Music
 
 gui.options.page.search.title=Search
 
+gui.sound_test.label.title=Sound Test
+gui.sound_test.label.repo=Sound Repository: %s
+gui.sound_test.label.id=ID: %s
+gui.sound_test.label.name=Name: %s
+gui.sound_test.label.url=URL: %s
+gui.sound_test.label.select_repo=Select Repo:
+gui.sound_test.label.select_entry=Select Entry:
+gui.sound_test.button.done=Done
+gui.sound_test.button.play=Play
+gui.sound_test.button.play_stream=Play Stream
+gui.sound_test.button.reload=Reload
+gui.sound_test.button.stop=Stop
+
+gui.texture_viewer.label.title=Texture Viewer
+
 gui.photo_mode.label.mouse_hint=Click and drag to move and rotate.
 gui.photo_mode.button.take_screenshot=Take Screenshot
 gui.photo_mode.button.center_camera=Center Camera
@@ -310,7 +339,6 @@ gui.model_viewer.slider.meta=Meta: %d
 gui.model_viewer.button.tickprogress=Run Tick: %s
 gui.model_viewer.button.rotate=Rotate Labels: %s
 gui.model_viewer.button.reload_textures=Reload Textures
-
 gui.model_viewer.button.category=Category
 
 model.category.entity.info=Entity: %s
@@ -344,4 +372,7 @@ model.category.particle.name=Particle
 model.category.particle.info=Particle: %s
 model.category.particle.radius.slider=Radius: %s
 model.category.particle.note.slider=Note: %s
-model.category.particle.block.side=Side: %s
\ No newline at end of file
+model.category.particle.block.side=Side: %s
+
+gui.credits.button.done=Done
+gui.credits.label.title=Credits
\ No newline at end of file
diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index 3f8f8fc72..077012dc7 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -293,6 +293,7 @@ item.bed.desc=Take a nap overnight.
 item.repeater.name=Redstone Repeater
 item.repeater.desc=Delays a redstone signal.
 item.map.name=Map
+item.map.blank.name=Blank Map
 item.map.desc=Chart your land!
 item.leaves.name=Leaves
 item.leaves.desc=Crunchy and green.
diff --git a/src/common/resources/lang/en_US/options.lang b/src/common/resources/lang/en_US/options.lang
index 9afc8e436..0f60ee1ae 100644
--- a/src/common/resources/lang/en_US/options.lang
+++ b/src/common/resources/lang/en_US/options.lang
@@ -69,6 +69,7 @@ options.animations.custom=Custom
 options.animations.procedural=Procedural
 options.animations.off=Off
 options.autoHit=Auto Hit
+options.easyBridge=Easy Bridge
 options.controller=Controller...
 options.controllerSensitivity=Sensitivity
 options.controllerMenuSensitivity=Menu Sensitivity
diff --git a/src/common/resources/lang/en_US/stats.lang b/src/common/resources/lang/en_US/stats.lang
index 070528eb8..f302a8bfa 100644
--- a/src/common/resources/lang/en_US/stats.lang
+++ b/src/common/resources/lang/en_US/stats.lang
@@ -30,6 +30,11 @@ stat.craftItem=%1$s Crafted
 stat.useItem=%1$s Used
 stat.breakItem=%1$s Depleted
 
+stat.crafted=Times Crafted
+stat.used=Times Used
+stat.mined=Times Mined
+stat.depleted=Times Depleted
+
 achievement.get=Achievement get!
 
 achievement.taken=Taken!
diff --git a/src/common/resources/lang/en_US/strings.lang b/src/common/resources/lang/en_US/strings.lang
index d7c6de7fa..269e2d9bd 100644
--- a/src/common/resources/lang/en_US/strings.lang
+++ b/src/common/resources/lang/en_US/strings.lang
@@ -61,6 +61,8 @@ worldType.overworld.classic.name=Classic
 worldType.overworld.classic.desc=Terrain generation similar to\nClassic, but infinite.
 worldType.overworld.indev.name=Indev
 worldType.overworld.indev.desc=Terrain generation similar to\nIndev, but infinite.
+worldType.overworld.skyblock.name=Skyblock
+worldType.overworld.skyblock.desc=Hardcore survival on a tiny\nisland in the sky.
 
 disconnect.genericReason=%s
 disconnect.disconnected=Disconnected by Server
diff --git a/src/main/java/net/betterthanadventure/sound/ChannelLWJGL3OpenAL.java b/src/main/java/net/betterthanadventure/sound/ChannelLWJGL3OpenAL.java
new file mode 100644
index 000000000..3e2816412
--- /dev/null
+++ b/src/main/java/net/betterthanadventure/sound/ChannelLWJGL3OpenAL.java
@@ -0,0 +1,335 @@
+package net.betterthanadventure.sound;
+
+import org.lwjgl.BufferUtils;
+import org.lwjgl.openal.AL10;
+import paulscode.sound.Channel;
+
+import javax.sound.sampled.AudioFormat;
+import java.nio.ByteBuffer;
+import java.nio.IntBuffer;
+import java.util.LinkedList;
+
+public class ChannelLWJGL3OpenAL extends Channel {
+    public IntBuffer ALSource;
+    public int ALformat;
+    public int sampleRate;
+    ByteBuffer bufferBuffer = BufferUtils.createByteBuffer(5242880);
+
+    public ChannelLWJGL3OpenAL(int var1, IntBuffer var2) {
+        super(var1);
+        this.libraryType = LibraryLWJGL3OpenAL.class;
+        this.ALSource = var2;
+    }
+
+    public void cleanup() {
+        if (this.ALSource != null) {
+            try {
+                AL10.alSourceStopv(this.ALSource);
+                AL10.alGetError();
+            } catch (Exception var3) {
+            }
+
+            try {
+                AL10.alDeleteSources(this.ALSource);
+                AL10.alGetError();
+            } catch (Exception var2) {
+            }
+
+            this.ALSource.clear();
+        }
+
+        this.ALSource = null;
+        super.cleanup();
+    }
+
+    public boolean attachBuffer(IntBuffer var1) {
+        if (this.errorCheck(this.channelType != 0, "Sound buffers may only be attached to normal sources.")) {
+            return false;
+        } else {
+            AL10.alSourcei(this.ALSource.get(0), 4105, var1.get(0));
+            return this.checkALError();
+        }
+    }
+
+    public void setAudioFormat(AudioFormat var1) {
+        boolean var2 = false;
+        short var3;
+        if (var1.getChannels() == 1) {
+            if (var1.getSampleSizeInBits() == 8) {
+                var3 = 4352;
+            } else {
+                if (var1.getSampleSizeInBits() != 16) {
+                    this.errorMessage("Illegal sample size in method 'setAudioFormat'");
+                    return;
+                }
+
+                var3 = 4353;
+            }
+        } else {
+            if (var1.getChannels() != 2) {
+                this.errorMessage("Audio data neither mono nor stereo in method 'setAudioFormat'");
+                return;
+            }
+
+            if (var1.getSampleSizeInBits() == 8) {
+                var3 = 4354;
+            } else {
+                if (var1.getSampleSizeInBits() != 16) {
+                    this.errorMessage("Illegal sample size in method 'setAudioFormat'");
+                    return;
+                }
+
+                var3 = 4355;
+            }
+        }
+
+        this.ALformat = var3;
+        this.sampleRate = (int)var1.getSampleRate();
+    }
+
+    public void setFormat(int var1, int var2) {
+        this.ALformat = var1;
+        this.sampleRate = var2;
+    }
+
+    public boolean preLoadBuffers(LinkedList var1) {
+        if (this.errorCheck(this.channelType != 1, "Buffers may only be queued for streaming sources.")) {
+            return false;
+        } else if (this.errorCheck(var1 == null, "Buffer List null in method 'preLoadBuffers'")) {
+            return false;
+        } else {
+            boolean var3 = this.playing();
+            if (var3) {
+                AL10.alSourceStop(this.ALSource.get(0));
+                this.checkALError();
+            }
+
+            int var4 = AL10.alGetSourcei(this.ALSource.get(0), 4118);
+            IntBuffer var2;
+            if (var4 > 0) {
+                var2 = BufferUtils.createIntBuffer(var4);
+                AL10.alGenBuffers(var2);
+                if (this.errorCheck(this.checkALError(), "Error clearing stream buffers in method 'preLoadBuffers'")) {
+                    return false;
+                }
+
+                AL10.alSourceUnqueueBuffers(this.ALSource.get(0), var2);
+                if (this.errorCheck(this.checkALError(), "Error unqueuing stream buffers in method 'preLoadBuffers'")) {
+                    return false;
+                }
+            }
+
+            if (var3) {
+                AL10.alSourcePlay(this.ALSource.get(0));
+                this.checkALError();
+            }
+
+            var2 = BufferUtils.createIntBuffer(var1.size());
+            AL10.alGenBuffers(var2);
+            if (this.errorCheck(this.checkALError(), "Error generating stream buffers in method 'preLoadBuffers'")) {
+                return false;
+            } else {
+                for(int var5 = 0; var5 < var1.size(); ++var5) {
+                    this.bufferBuffer.clear();
+                    this.bufferBuffer.put((byte[])var1.get(var5), 0, ((byte[])var1.get(var5)).length);
+                    this.bufferBuffer.flip();
+
+                    try {
+                        AL10.alBufferData(var2.get(var5), this.ALformat, this.bufferBuffer, this.sampleRate);
+                    } catch (Exception var8) {
+                        this.errorMessage("Error creating buffers in method 'preLoadBuffers'");
+                        this.printStackTrace(var8);
+                        return false;
+                    }
+
+                    if (this.errorCheck(this.checkALError(), "Error creating buffers in method 'preLoadBuffers'")) {
+                        return false;
+                    }
+                }
+
+                try {
+                    AL10.alSourceQueueBuffers(this.ALSource.get(0), var2);
+                } catch (Exception var7) {
+                    this.errorMessage("Error queuing buffers in method 'preLoadBuffers'");
+                    this.printStackTrace(var7);
+                    return false;
+                }
+
+                if (this.errorCheck(this.checkALError(), "Error queuing buffers in method 'preLoadBuffers'")) {
+                    return false;
+                } else {
+                    AL10.alSourcePlay(this.ALSource.get(0));
+                    return !this.errorCheck(this.checkALError(), "Error playing source in method 'preLoadBuffers'");
+                }
+            }
+        }
+    }
+
+    public boolean queueBuffer(byte[] var1) {
+        if (this.errorCheck(this.channelType != 1, "Buffers may only be queued for streaming sources.")) {
+            return false;
+        } else {
+            this.bufferBuffer.clear();
+            this.bufferBuffer.put(var1, 0, var1.length);
+            this.bufferBuffer.flip();
+            IntBuffer var2 = BufferUtils.createIntBuffer(1);
+            AL10.alSourceUnqueueBuffers(this.ALSource.get(0), var2);
+            if (this.checkALError()) {
+                return false;
+            } else {
+                AL10.alBufferData(var2.get(0), this.ALformat, this.bufferBuffer, this.sampleRate);
+                if (this.checkALError()) {
+                    return false;
+                } else {
+                    AL10.alSourceQueueBuffers(this.ALSource.get(0), var2);
+                    return !this.checkALError();
+                }
+            }
+        }
+    }
+
+    public int feedRawAudioData(byte[] var1) {
+        if (this.errorCheck(this.channelType != 1, "Raw audio data can only be fed to streaming sources.")) {
+            return -1;
+        } else {
+            ByteBuffer var2 = ByteBuffer.wrap(var1, 0, var1.length);
+            int var4 = AL10.alGetSourcei(this.ALSource.get(0), 4118);
+            IntBuffer var3;
+            if (var4 > 0) {
+                var3 = BufferUtils.createIntBuffer(var4);
+                AL10.alGenBuffers(var3);
+                if (this.errorCheck(this.checkALError(), "Error clearing stream buffers in method 'feedRawAudioData'")) {
+                    return -1;
+                }
+
+                AL10.alSourceUnqueueBuffers(this.ALSource.get(0), var3);
+                if (this.errorCheck(this.checkALError(), "Error unqueuing stream buffers in method 'feedRawAudioData'")) {
+                    return -1;
+                }
+            } else {
+                var3 = BufferUtils.createIntBuffer(1);
+                AL10.alGenBuffers(var3);
+                if (this.errorCheck(this.checkALError(), "Error generating stream buffers in method 'preLoadBuffers'")) {
+                    return -1;
+                }
+            }
+
+            AL10.alBufferData(var3.get(0), this.ALformat, var2, this.sampleRate);
+            if (this.checkALError()) {
+                return -1;
+            } else {
+                AL10.alSourceQueueBuffers(this.ALSource.get(0), var3);
+                if (this.checkALError()) {
+                    return -1;
+                } else {
+                    if (this.attachedSource != null && this.attachedSource.channel == this && this.attachedSource.active() && !this.playing()) {
+                        AL10.alSourcePlay(this.ALSource.get(0));
+                        this.checkALError();
+                    }
+
+                    return var4;
+                }
+            }
+        }
+    }
+
+    public int buffersProcessed() {
+        if (this.channelType != 1) {
+            return 0;
+        } else {
+            int var1 = AL10.alGetSourcei(this.ALSource.get(0), 4118);
+            return this.checkALError() ? 0 : var1;
+        }
+    }
+
+    public void flush() {
+        if (this.channelType == 1) {
+            int var1 = AL10.alGetSourcei(this.ALSource.get(0), 4117);
+            if (!this.checkALError()) {
+                for(IntBuffer var2 = BufferUtils.createIntBuffer(1); var1 > 0; --var1) {
+                    try {
+                        AL10.alSourceUnqueueBuffers(this.ALSource.get(0), var2);
+                    } catch (Exception var4) {
+                        return;
+                    }
+
+                    if (this.checkALError()) {
+                        return;
+                    }
+                }
+
+            }
+        }
+    }
+
+    public void close() {
+        try {
+            AL10.alSourceStop(this.ALSource.get(0));
+            AL10.alGetError();
+        } catch (Exception var2) {
+        }
+
+        if (this.channelType == 1) {
+            this.flush();
+        }
+
+    }
+
+    public void play() {
+        AL10.alSourcePlay(this.ALSource.get(0));
+        this.checkALError();
+    }
+
+    public void pause() {
+        AL10.alSourcePause(this.ALSource.get(0));
+        this.checkALError();
+    }
+
+    public void stop() {
+        AL10.alSourceStop(this.ALSource.get(0));
+        this.checkALError();
+    }
+
+    public void rewind() {
+        if (this.channelType != 1) {
+            AL10.alSourceRewind(this.ALSource.get(0));
+            this.checkALError();
+        }
+    }
+
+    public boolean playing() {
+        int var1 = AL10.alGetSourcei(this.ALSource.get(0), 4112);
+        if (this.checkALError()) {
+            return false;
+        } else {
+            return var1 == 4114;
+        }
+    }
+
+    private boolean checkALError() {
+        switch( AL10.alGetError() )
+        {
+            case AL10.AL_NO_ERROR:
+                return false;
+            case AL10.AL_INVALID_NAME:
+                errorMessage( "Invalid name parameter." );
+                return true;
+            case AL10.AL_INVALID_ENUM:
+                errorMessage( "Invalid parameter." );
+                return true;
+            case AL10.AL_INVALID_VALUE:
+                errorMessage( "Invalid enumerated parameter value." );
+                return true;
+            case AL10.AL_INVALID_OPERATION:
+                errorMessage( "Illegal call." );
+                return true;
+            case AL10.AL_OUT_OF_MEMORY:
+                errorMessage( "Unable to allocate memory." );
+                return true;
+            default:
+                errorMessage( "An unrecognized error occurred." );
+                return true;
+        }
+    }
+
+}
